#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll k, n;
    cin >> k >> n;
    ll x = 0, y = 0;
    vector<vector<ll>> s(4001, vector<ll>(4001));

    vector<char> d1(n, 'a');
    vector<ll> a1(n);
    bool q = true;
    for (ll i = 0; i < n; i++) {
        cin >> d1[i] >> a1[i];
        if (a1[i] != k) {
            q = false;
        }
    }

    if (q) {
        set<pair<ll, ll>> st;

        st.insert({0, 0});

        for (ll o = 0; o < n; o++) {
            char d = d1[o];
            ll a = 1;
            if (d == 'N') {
                y += a;
                st.insert({x, y});
            } else if (d == 'S') {
                y -= a;
                st.insert({x, y});
            } else if (d == 'E') {
                x += a;
                st.insert({x, y});
            } else {
                x -= a;
                st.insert({x, y});
            }
        }
        ll ans = (ll) st.size();
        cout << ans * k * k;
        return 0;
    }

    for (ll i = 0; i < k; i++) {
        for (ll j = 0; j < k; j++) {
            s[i + 2000][j + 2000] = 1;
        }
    }

    if (k > 1) {
        for (ll o = 0; o < n; o++) {
            char d = d1[o];
            ll a = a1[o];
            if (d == 'N') {
                for (ll i = x; i < x + k; i++) {
                    for (ll j = y + k; j < y + k + a; j++) {
                        s[i + 2000][j + 2000] = 1;
                    }
                }
                y += a;
            } else if (d == 'S') {
                for (ll i = x; i < x + k; i++) {
                    for (ll j = y - 1; j >= y - a; j--) {
                        s[i + 2000][j + 2000] = 1;
                    }
                }
                y -= a;
            } else if (d == 'E') {
                for (ll i = x + k; i < x + k + a; i++) {
                    for (ll j = y; j < y + k; j++) {
                        s[i + 2000][j + 2000] = 1;
                    }
                }
                x += a;
            } else {
                for (ll i = x - 1; i >= x - a; i--) {
                    for (ll j = y; j < y + k; j++) {
                        s[i + 2000][j + 2000] = 1;
                    }
                }
                x -= a;
            }
        }
        ll ans = 0;
        for (ll i = 0; i <= 4000; i++) {
            for (ll j = 0; j <= 4000; j++) {
                ans += s[i][j];
            }
        }
        cout << ans;
        return 0;
    }

    unordered_map<ll, set<pair<ll, ll>>> vertical, horizontal;
    ll ans = 0;
    for (ll o = 0; o < n; o++) {
        char d = d1[o];
        ll a = a1[o];
        ans += a;
        ll l, r;
        if (d == 'N') {
            l = y + 1;
            r = y + a;
            y += a;
        } else if (d == 'S') {
            l = y - a;
            r = y - 1;
            y -= a;
        } else if (d == 'E') {
            l = x + 1;
            r = x + a;
            x += a;
        } else {
            l = x - a;
            r = x - 1;
            x -= a;
        }
        if (d == 'N' || d == 'S') {
            vector<pair<ll, ll>> gg;
            for (auto &i: vertical[x]) {
                ll l1 = i.first, r1 = i.second;
                ll l2 = max(l, l1), r2 = min(r, r1);
                if (l2 > r2) {
                    continue;
                }
                ans -= r2 - l2 + 1;
                vertical[x].erase(i);
                gg.push_back(i);
            }
            ll l2 = l, r2 = r;
            for (auto &i: gg) {
                if (i.first < l2) {
                    l2 = i.first;
                }
                if (i.second < r2) {
                    r2 = i.second;
                }
            }
            vertical[x].insert({l2, r2});
            for (auto &i: horizontal) {
                for (auto &j: i.second) {
                    ll l1 = j.first, r1 = j.second;
                    if (l <= i.first && i.first <= r && l1 <= x && x <= r1) {
                        ans--;
                    }
                    if (l2 <= i.first && i.first <= r2 && l1 <= x && x <= r1) {
                        i.second.erase(j);
                        i.second.insert({l2, x - 1});
                        i.second.insert({x + 1, r2});
                    }
                }
            }
        } else {
            vector<pair<ll, ll>> gg;
            for (auto &i: horizontal[y]) {
                ll l1 = i.first, r1 = i.second;
                ll l2 = max(l, l1), r2 = min(r, r1);
                if (l2 > r2) {
                    continue;
                }
                ans -= r2 - l2 + 1;
                horizontal[y].erase(i);
                gg.push_back(i);
            }
            ll l2 = l, r2 = r;
            for (auto &i: gg) {
                if (i.first < l2) {
                    l2 = i.first;
                }
                if (i.second < r2) {
                    r2 = i.second;
                }
            }
            horizontal[y].insert({l2, r2});
            for (auto &i: vertical) {
                for (auto &j: i.second) {
                    ll l1 = j.first, r1 = j.second;
                    if (l <= i.first && i.first <= r && l1 <= y && y <= r1) {
                        ans--;
                    }
                    if (l2 <= i.first && i.first <= r2 && l1 <= y && y <= r1) {
                        i.second.erase(j);
                        i.second.insert({l2, y - 1});
                        i.second.insert({y + 1, r2});
                    }
                }
            }
        }

    }
    cout << ans;
}