#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct ST {
    vector<ll> a;
    vector<vector<ll>> mx;
    vector<ll> lg;
    ll n, k;

    ST(vector<ll> &a) {
        this->a = a;
        n = (ll) a.size();
        k = 0;
        while ((1 << k) <= n) {
            k++;
        }
        mx.assign(k, vector<ll>(n));
        for (ll i = 0; i < n; i++) {
            mx[0][i] = i;
        }

        for (ll i = 1; i < k; i++) {
            for (ll j = 0; j + (1 << i) <= n; j++) {
                ll i1 = mx[i - 1][j];
                ll i2 = mx[i - 1][j + (1 << (i - 1))];
                if (a[i1] > a[i2]) {
                    mx[i][j] = mx[i - 1][j];
                } else {
                    mx[i][j] = mx[i - 1][j + (1 << (i - 1))];
                }
            }
        }

        lg.assign(n + 1, 0);
        for (ll i = 2; i <= n; i++) {
            lg[i] = lg[i / 2] + 1;
        }
    }

    ll get(ll l, ll r) {
        ll x = lg[r - l];
        if (a[mx[x][l]] > a[mx[x][r - (1 << x)]]) {
            return mx[x][l];
        } else {
            return mx[x][r - (1 << x)];
        }
    }
};

vector<ll> a;
ll n;

ll foo(ll i, ll k) {
    ll l = i, r = i + 1;
    vector<ll> b = {l};

    ll x = 1;
    while (0 < l && r < n && x < k) {
        if (a[l - 1] < a[r]) {
            b.push_back(l - 1);
            l--;
        } else {
            b.push_back(r);
            r++;
        }
        x++;
    }
    while (l > 0 && x < k) {
        b.push_back(l - 1);
        l--;
        x++;
    }
    while (r < n && x < k) {
        b.push_back(r);
        r++;
        x++;
    }
    return b[k - 1];
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll q;
    cin >> n >> q;
    a.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    ST st(a);
    while (q--) {
        ll p, k;
        cin >> p >> k;
        p--;
        ll l = 0, r = n;
        ll ans = 0;
        while (true) {
            ll m = st.get(l, r);
            ll x = m - l, y = r - m - 1;
            if (foo(m, k) == p) {
                ans++;
            }
            if (p == m) {
                if (k == x + 1) {
                    ans += x;
                }
                if (k == y + 1) {
                    ans += y;
                }
                break;
            }
            if (p < m) {
                if (r - p == k) {
                    ans += y;
                }
                r = m;
            } else {
                if (p - l + 1 == k) {
                    ans += x;
                }
                l = m + 1;
            }
        }
        cout << ans << '\n';
    }
}