#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> fact, inv;
ll mod = 1e9 + 7;

ll pow(ll a, ll x) {
    if (x == 0) {
        return 1;
    }
    ll q = pow(a, x / 2);
    if (x % 2 == 0) {
        return (q * q) % mod;
    } else {
        return ((q * q) % mod * a) % mod;
    }
}

ll C(ll n, ll k) {
    if (k > n) {
        return 0;
    }
    if (k == 0) {
        return 1;
    }
    ll res = fact[n];
    res = (res * inv[k]) % mod;
    res = (res * inv[n - k]) % mod;
    return res;
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m;
    cin >> n >> m;
    vector<ll> A(m);
    for (ll i = 0; i < m; i++) {
        cin >> A[i];
    }
    fact.assign(n + 1, 1);
    for (ll i = 1; i <= n; i++) {
        fact[i] = (fact[i - 1] * i) % mod;
    }
    inv.assign(n + 1, 0);
    for (ll i = 0; i <= n; i++) {
        inv[i] = pow(fact[i], mod - 2);
    }
    if (m == 2 && A[0] == 1 && A[1] == 2) {
        ll ans = 0;
        for (ll k = 0; k <= n; k++) {
            ans = (ans + C(n - k + 1, k)) % mod;
        }
        cout << ans;
    }
    if (m == 2 && A[0] == 2 && A[1] == 1) {
        ll ans = 0;
        for (ll k = 0; k <= n; k++) {
            ans = (ans + C(n - k + 1, k)) % mod;
        }
        cout << ans;
    }
}
