#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<ll> fact, inv;
ll mod = 1e9 + 7;

ll pow(ll a, ll x) {
    if (x == 0) {
        return 1;
    }
    ll q = pow(a, x / 2);
    if (x % 2 == 0) {
        return (q * q) % mod;
    } else {
        return ((q * q) % mod * a) % mod;
    }
}

ll C(ll n, ll k) {
    if (k > n) {
        return 0;
    }
    if (k == 0) {
        return 1;
    }
    ll res = fact[n];
    res = (res * inv[k]) % mod;
    res = (res * inv[n - k]) % mod;
    return res;
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll g, q;
    cin >> g >> q;
    ll n = 1e6;
    fact.assign(n + 1, 1);
    for (ll i = 1; i <= n; i++) {
        fact[i] = (fact[i - 1] * i) % mod;
    }
    inv.assign(n + 1, 0);
    for (ll i = 0; i <= n; i++) {
        inv[i] = pow(fact[i], mod - 2);
    }

    if (g == 1) {
        while (q--) {
            string s;
            cin >> s;
            ll x = 0, y = 0, z = 0, t = 0;
            for (ll i = 0; i < s.size() - 1; i++) {
                if (s[i] == 'a' && s[i + 1] == 'a') {
                    x++;
                } else if (s[i] == 'b' && s[i + 1] == 'b') {
                    y++;
                } else if (s[i] == 'a' && s[i + 1] == 'b') {
                    z++;
                } else if (s[i] == 'b' && s[i + 1] == 'a') {
                    t++;
                }
            }
            ll ans = 0;
            if (z == t) {
                ll a = x + z + 1;
                ll b = y + z;

                ans = (ans + C(a - 1, z) * C(b - 1, z - 1)) % mod;

                a = x + z;
                b = y + z + 1;
                ans = (ans + C(a - 1, z - 1) * C(b - 1, z)) % mod;
            } else if (z > t) {
                ll a = x + z;
                ll b = y + z;

                ans = (ans + C(a - 1, z - 1) * C(b - 1, z - 1)) % mod;
            } else {
                ll a = x + t;
                ll b = y + t;

                ans = (ans + C(a - 1, z - 1) * C(b - 1, z - 1)) % mod;
            }
            cout << ans << '\n';
        }
    }
}